<?
// ---------------------------------------------------------------
// PHPnetemGUI
//
// Copyright 2005 British Telecommunications plc
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc.
// 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// ---------------------------------------------------------------

//****************************************************************************
//Main function which creates and runs the netem rules based on the user input
//****************************************************************************
function make_command($interfaces, $del, $delJitter, $delCorrelation, $delDistribution, $loss, $lossCorrelation, $dup, $dupCorrelation, $reorder, $reorderCorrelation, $gap, $bandwidth, $limit, $combination, $displayCmd, $src, $srcSub, $dest, $destSub, $storedCommands, $advancedMode)
{

	//Make an array containing all possible handle strings
	$handleid  =  array(1 => 'root', 1, 10, 20, 30, 40, 50, 60, 70);
	//Reset storedCommands variable
	$storedCommands="";

	//If in advanced mode then set a separate handle counter
	if ($advancedMode & ($src[0]!="any" | $dest[0]!="any")) {
		$ha=10; //$ha = 'handle advanced'
		$pa=1; //$pa = 'parent advanced'
		$prioLineAdded=false; //This flag is to make sure that the prio command is only added once
	}
	//Loop through all interfaces in the $interfaces[] array
	for ($x=0; $x<count($interfaces); $x++) {

		//If the interface element is empty then that means the interface that was there is to be ignored,
		//therefore skip the following code and move to the next interface.
		if (!empty($interfaces[$x])) {
			$interface=$interfaces[$x];
	
			//Point $h to first handle
			$h=1;
			//Reset command
			$command="";
	
			//Check for specified ip address matching
			//If an ip address for the interface is anything other than "any" OR $advancedMode
			//then add a prio command first.
			global $tc_CMD;
			if ($prioLineAdded==false) {
				if ($src[0]!="any" | $dest[0]!="any") {
					++$h;
					$command=$tc_CMD.' qdisc add dev '. $interface . ' root handle 1: prio bands 10';
					//Add the command to $displayCmd if necessary
					if (isset($_POST['chkDisplay'])) {
						//Strip 'sudo' and '/path/' from the start of the command
						//find /tc in $command then set $displayCmd to substr($command, [/ in /tc])
						$n=strpos($command, "/tc");
						$displayCmd=$displayCmd . substr($command, $n+1) . "</br>";
					} else {
						//Add the command to the storedCommands variable
						$storedCommands=$storedCommands . $command . "\n";
						//Run the command
						exec($command);
					}
				}
			}
	
			//Set $prioLineAdded to true if in advanced mode
			if ($advancedMode & ($src[0]!="any" | $dest[0]!="any")) {
				$prioLineAdded=true;
			}
	
			//**Check all elements of the $combination array**
	
			//Check for delay
			if ($combination[$x][1]==TRUE) {
				//Use next handle
				if ($advancedMode & ($src[0]!="any" | $dest[0]!="any")) {
					$delayHandle=$ha;
					$delayParent=$pa;
					//Set $pa to handle
					$pa=$ha;
					//increment $ha
					++$ha;
				} else {
					$delayHandle=$handleid[$h+1];
					$delayParent=$handleid[$h];
					//increment $h
					++$h;
				}
	
				//Create delay command (including reordering if necessary)
				if ($combination[$x][4]==TRUE) {
					delay_command($x, $interface, $delayParent, $delayHandle, &$command, $del, $delJitter, $delCorrelation, $reorder, $reorderCorrelation, $gap, $delDistribution, $limit, $src, $dest, &$displayCmd, &$storedCommands, $advancedMode);
				} else {
					delay_command($x, $interface, $delayParent, $delayHandle, &$command, $del, $delJitter, $delCorrelation,0, 0, 0, $delDistribution, $limit, $src, $dest, &$displayCmd, &$storedCommands, $advancedMode);
				}
			}
			//Check for loss
			if ($combination[$x][2]==TRUE) {
				//Use next handle
				if ($advancedMode & ($src[0]!="any" | $dest[0]!="any")) {
					$lossHandle=$ha;
					$lossParent=$pa;
					//Set $pa to handle
					$pa=$ha;
					//increment $ha
					++$ha;
				} else {
					$lossHandle=$handleid[$h+1];
					$lossParent=$handleid[$h];
					//increment $h
					++$h;
				}
				//Create loss command
				loss_command($x, $interface, $lossParent, $lossHandle, &$command, $loss, $lossCorrelation, $limit, $src, $dest, &$displayCmd, &$storedCommands, $advancedMode);
			}
	
			//Check for duplication
			if ($combination[$x][3]==TRUE) {
				//Use next handle
				if ($advancedMode & ($src[0]!="any" | $dest[0]!="any")) {
					$duplicationHandle=$ha;
					$duplicationParent=$pa;
					//Set $pa to handle
					$pa=$ha;
					//increment $ha
					++$ha;
				} else {
					$duplicationHandle=$handleid[$h+1];
					$duplicationParent=$handleid[$h];
					//increment $h
					++$h;
				}
				//Create duplication command
				duplication_command ($x, $interface, $duplicationParent, $duplicationHandle, &$command, $dup, $dupCorrelation, $limit, $src, $dest, &$displayCmd, &$storedCommands, $advancedMode);
			}
	
			//Check for bandwidth
			if ($combination[$x][5]==TRUE) {
				//Use next handle
				if ($advancedMode & ($src[0]!="any" | $dest[0]!="any")) {
					$bandwidthHandle=$ha;
					$bandwidthParent=$pa;
				} else {
					$bandwidthHandle=$handleid[$h+1];
					$bandwidthParent=$handleid[$h];
				}
				//Create bandwidth command
				bandwidth_command ($x, $interface, $handleid, $h, $bandwidthParent, $bandwidthHandle, &$command, $bandwidth, $src, $dest, &$displayCmd, &$storedCommands, $advancedMode);
			}
	
			if (!$advancedMode) {
				//Check for ip address matching
				if ($src[$x]!="any" | $dest[$x]!="any") {
					//Create ip address matching command
					ip_command($x, $interface, $h, $src, $srcSub, $dest, $destSub, &$displayCmd, &$storedCommands, $advancedMode);
				}
			}
			//Set $ha to the next multiple of 10
			While ($ha % 10 != 0):
				++$ha;
			endwhile;
	
			//Reset $pa to 1
			$pa=1;
		}
	}

	//Do the advanced mode IP matching commands
	if ($advancedMode & ($src[0]!="any" | $dest[0]!="any")) {
		for ($x=0; $x<count($interfaces); $x++) {
			//Create ip address matching command
			ip_command($x, $interface, $h, $src, $srcSub, $dest, $destSub, &$displayCmd, &$storedCommands, $advancedMode);
		}
	}
	//Add the final qdisc and filter rule to direct all non-matching traffic to a pfifo queue
	//If in basic mode then loop through all interfaces, else just loop through the single interface in
	//advanced mode
	if ($advancedMode) {
		$loop=1;
	} else {
		$loop=count($interfaces);
	}
	for ($x=0; $x<$loop; $x++) {
		if ($src[$x]!="any" | $dest[$x]!="any") {
			$i=1;
			while ($i<=2):
				switch ($i) {
					case 1:
					if ($advancedMode) {
						$tree = " parent $pa:" . (count($interfaces)+1) . " handle $ha: ";
					} else {
						$tree = $tree = " parent $pa:2 handle 20: ";
					}
					$command=$tc_CMD.' qdisc add dev '. $interfaces[$x] . $tree . ' pfifo';
					break;

					case 2:
					if ($advancedMode) {
						$command=$tc_CMD . ' filter add dev ' . $interfaces[$x] . ' protocol ip parent 1:0 prio ' . (count($interfaces)+1) . ' u32 match ip src 0.0.0.0/0 match ip dst 0.0.0.0/0 flowid ' . (count($interfaces)+1) * 10 . ':' . (count($interfaces)+1);
					} else {
						$command=$tc_CMD . ' filter add dev ' . $interfaces[$x] . ' protocol ip parent 1:0 prio 2 u32 match ip src 0.0.0.0/0 match ip dst 0.0.0.0/0 flowid 20:2' ;
					}
					break;
				}
				//Add the command to $displayCmd if necessary
				if (isset($_POST['chkDisplay'])) {
					//Strip 'sudo' and '/path/' from the start of the command
					$n=strpos($command, "/tc");
					$displayCmd=$displayCmd . substr($command, $n+1) . "</br>";
				} else {
					//Add the command to the storedCommands variable
					$storedCommands=$storedCommands . $command . "\n";
					//Run the command
					exec($command);
				}
				++$i;
			endwhile;
		}
	}
}

//******************************************
//Function to create the netem delay command
//******************************************


function delay_command($x, $interface, $delayParent, $delayHandle, $command, $del, $delJitter, $delCorrelation, $reorder, $reorderCorrelation, $gap, $delDistribution, $limit, $src, $dest, &$displayCmd, $storedCommands, $advancedMode)
{
	global $tc_CMD;
	if ($advancedMode & ($src[0]!="any" | $dest[0]!="any")) {
		//Set correct handle and parent, the parent minor number will be $x+1
		$tree = " parent $delayParent:" . ($x+1) . " handle $delayHandle: ";
	} else {
		if ($delayParent != 'root') {
			$tree = " parent $delayParent:1 handle $delayHandle: ";
		} else {
		$tree = " root handle $delayHandle: ";
		}
	}
	if (empty($delCorrelation[$x])==FALSE and empty($delJitter[$x])==FALSE ) {
		//First 3 actions
		$command=$tc_CMD.' qdisc add dev '. $interface .
						$tree .
						'netem delay '. $del[$x] . 'ms ' .
						$delJitter[$x] . 'ms ' . $delCorrelation[$x] . '%';
	} elseif (empty($delCorrelation[$x]) and empty($delJitter[$x])==FALSE ) {
		//First 2 actions
		$command=$tc_CMD.' qdisc add dev '. $interface .
						$tree .
						'netem delay '. $del[$x] . 'ms ' . $delJitter[$x] . 'ms';
	} elseif (empty($delCorrelation[$x]) and empty($delJitter[$x]) ) {
		//just delay time
		$command=$tc_CMD.' qdisc add dev '. $interface .
						$tree .
						'netem delay '. $del[$x] . 'ms';
	} elseif (empty($delCorrelation[$x])==FALSE and empty($delJitter[$x]) ) {
		//Delay time and correlation but not jitter (just ignores correlation value)
		$command=$tc_CMD.' qdisc add dev '. $interface .
						$tree .
						'netem delay '. $del[$x] . 'ms';
	}

	//Add reorder commands if necessary
	if ($reorder[$x]>0) {
		$command=$command . ' reorder ' . $reorder[$x] . '%';
		if ($reorderCorrelation[$x]>0) {
			$command=$command . ' ' . $reorderCorrelation[$x] . '%';
		}
		if ($gap[$x]>0) {
			$command=$command . ' gap ' . $gap[$x];
		}
	}
	
	//Add distribution if necessary
	if ($delDistribution[$x]!="-N/A-" & $delJitter[$x]>0) {
		$command=$command . ' distribution ' . strtolower($delDistribution[$x]);
	}

	//Add packet limit if necessary
	if (($limit[$x]>0) and ($limit[$x]!=1000)) {
		$command=$command . ' limit ' .$limit[$x];
	}

	//Add the command to $displayCmd if necessary
	if (isset($_POST['chkDisplay'])) {
		//Strip 'sudo' and '/path/' from the start of the command
		$n=strpos($command, "/tc");
		$displayCmd=$displayCmd . substr($command, $n+1) . "</br>";
	} else {
		//Add the command to the storedCommands variable
		$storedCommands=$storedCommands . $command . "\n";
		//Run the command
		exec($command);
	}
}

//*****************************************
//Function to create the netem loss command
//*****************************************
function loss_command($x, $interface, $lossParent, $lossHandle, $command, $loss, $lossCorrelation, $limit, $src, $dest, $displayCmd, $storedCommands, $advancedMode)
{
	global $tc_CMD;
	if ($advancedMode & ($src[0]!="any" | $dest[0]!="any")) {
		//Set correct handle and parent, the parent minor number will be $x+1
		$tree = " parent $lossParent:" . ($x+1) . " handle $lossHandle: ";
	} else {
		//Loss and correlation
		if ($lossParent != 'root') {
			$tree = " parent $lossParent:1 handle $lossHandle: ";
		} else {
			$tree = " root handle $lossHandle: ";
		}
	}
	if (empty($lossCorrelation[$x])==FALSE) {
		$command=$tc_CMD.' qdisc add dev '. $interface .
						$tree .
						'netem loss '. $loss[$x] . '% ' . $lossCorrelation[$x] . '%';
	//Just loss percentage
	} elseif (empty($lossCorrelation[$x]))  {
		$command=$tc_CMD.' qdisc add dev '. $interface .
						$tree .
						'netem loss '. $loss[$x] . '%';
	}
	//Add packet limit if necessary
	if (($limit[$x]>0) and ($limit[$x]!=1000)) {
		$command=$command . ' limit ' .$limit[$x];
	}
	//Add the command to $displayCmd if necessary
	if (isset($_POST['chkDisplay'])) {
		//Strip 'sudo' and '/path/' from the start of the command
		$n=strpos($command, "/tc");
		$displayCmd=$displayCmd . substr($command, $n+1) . "</br>";
	} else {
		//Add the command to the storedCommands variable
		$storedCommands=$storedCommands . $command . "\n";
		//Run the command
		exec($command);
	}
}

//************************************************
//Function to create the netem duplication command
//************************************************
function duplication_command ($x, $interface, $duplicationParent, $duplicationHandle, $command, $dup, $dupCorrelation, $limit, $src, $dest, $displayCmd, $storedCommands, $advancedMode)
{
	global $tc_CMD;
	//Duplication and correlation
	if ($advancedMode & ($src[0]!="any" | $dest[0]!="any")) {
		//Set correct handle and parent, the parent minor number will be $x+1
		$tree = " parent $duplicationParent:" . ($x+1) . " handle $duplicationHandle: ";
	} else {
		if ($duplicationParent != 'root') {
			$tree = " parent $duplicationParent:1 handle $duplicationHandle: ";
		} else {
			$tree = " root handle $duplicationHandle: ";
		}
	}
	if (empty($dupCorrelation[$x])==FALSE) {
		$command=$tc_CMD.' qdisc add dev '. $interface .
						$tree .
						'netem duplicate '. $dup[$x] . '% ' . $dupCorrelation[$x] . '%';
	//Just loss percentage
	} elseif (empty($dupCorrelation[$x]))  {
		$command=$tc_CMD.' qdisc add dev '. $interface .
						$tree .
						'netem duplicate '. $dup[$x] . '%';
	}
	//Add packet limit if necessary
	if (($limit[$x]>0) and ($limit[$x]!=1000)) {
		$command=$command . ' limit ' .$limit[$x];
	}
	//Add the command to $displayCmd if necessary
	if (isset($_POST['chkDisplay'])) {
		//Strip 'sudo' and '/path/' from the start of the command
		$n=strpos($command, "/tc");
		$displayCmd=$displayCmd . substr($command, $n+1) . "</br>";
	} else {
		//Add the command to the storedCommands variable
		$storedCommands=$storedCommands . $command . "\n";
		//Run the command
		exec($command);
	}
}

//****************************************
//Function to create the bandwidth command
//****************************************
function bandwidth_command ($x, $interface, $handleid, $h, $bandwidthParent, $bandwidthHandle, $command, $bandwidth, $src, $dest, $displayCmd, $storedCommands, $advancedMode)
{
	global $tc_CMD;
	//Create the 3 bandwidth commands
	for ($i=1; $i<=2; ++$i) {
		if ($advancedMode & ($src[0]!="any" | $dest[0]!="any")) {
			//Set correct handle and parent, the parent minor number will be $x+1
			$tree = " parent $bandwidthParent:" . ($x+1) . " handle $bandwidthHandle: ";
		} else {
			if ($bandwidthParent != 'root') {
				$tree = " parent $bandwidthParent:1 handle $bandwidthHandle: ";
			} else {
				$tree = " root handle $bandwidthHandle: ";
			}
		}
		switch ($i) {
			case 1:
			//Bandwidth 1: Add htb qdisc
			$command=$tc_CMD.' qdisc add dev '. $interface .
						$tree .
						'htb default 1';
			break;
			case 2:
			//Bandwidth 2: Add bandwidth vlaue
			$command=$tc_CMD.' class add dev '. $interface .
						' parent ' . $bandwidthHandle . ': classid 0:1' .
						' htb rate '.  $bandwidth[$x] . 'kbit ceil ' . $bandwidth[$x] .
						'kbit';
			break;
		}
		//Add the command to $displayCmd if necessary
		if (isset($_POST['chkDisplay'])) {
			//Strip 'sudo' and '/path/' from the start of the command
			$n=strpos($command, "/tc");
		$displayCmd=$displayCmd . substr($command, $n+1) . "</br>";
		} else {
			//Add the command to the storedCommands variable
			$storedCommands=$storedCommands . $command . "\n";
			//Run the command
			exec($command);
		}
	}

}

//**************************************************
//Function to create the ip address matching command
//**************************************************
function ip_command($x, $interface, $h, $src, $srcSub, $dest, $destSub, &$displayCmd, $storedCommands, $advancedMode)
{
	global $tc_CMD;

	//Create the beginning of the command
	if ($advancedMode) {
		$command=$tc_CMD. ' filter add dev ' . $interface . ' protocol ip parent 1:0 prio ' . ($x+1) . ' u32 ';
	} else {
		$command=$tc_CMD. ' filter add dev ' . $interface . ' protocol ip parent 1:0 prio 1 u32 ';
	}
	//Check if source address has an ip address specified
	if ($src[$x]!="any") {
		$command=$command . ' match ip src ' . $src[$x] . '/' . $srcSub[$x];
	}
	//Check if destination address has an ip address specified
	if ($dest[$x]!="any") {
		$command=$command . ' match ip dst ' . $dest[$x] . '/' . $destSub[$x];
	}
	//Add the flowid part to the command
	if ($advancedMode & ($src[0]!="any" | $dest[0]!="any")) {
		$command=$command . ' flowid ' . ($x+1) * 10 . ':' . ($x+1);
	} else {
		$command=$command . ' flowid 10:1';
	}
	//Add the command to $displayCmd if necessary
	if (isset($_POST['chkDisplay'])) {
		//Strip 'sudo' and '/path/' from the start of the command
		$n=strpos($command, "/tc");
		$displayCmd=$displayCmd . substr($command, $n+1) . "</br>";
	} else {
		//Add the command to the storedCommands variable
		$storedCommands=$storedCommands . $command . "\n";
		//Run the command
		exec($command);

	}
}

//*********************************************************************
//Function to reset the netem values for all interfaces being displayed
//*********************************************************************
function reset_tc($interfaces, $displayCmd)
{
	global $tc_CMD;
	//Remove all currently running netem commands from the all interfaces.
	for ($i=0; $i<count($interfaces); ++$i) {
		//Build the command
		$command=$tc_CMD.' qdisc del dev '. $interfaces[$i] .' root';
		//Add the command to $displayCmd if necessary
		if (isset($_POST['chkDisplay']) & isset($_POST['btnReset'])==false) {
			//Strip 'sudo' and '/path/' from the start of the command
			$n=strpos($command, "/tc");
			$displayCmd=$displayCmd . substr($command, $n+1) . "</br>";
		} else {
			exec($command);
		}
	}
}
?>
