<?
// ---------------------------------------------------------------
// PHPnetemGUI
//
// Copyright 2005 British Telecommunications plc
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc.
// 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// ---------------------------------------------------------------

//***************************************************************************************
//Function to replace the $_POST values with the netem values which are currently running
//on a selected interface.
//***************************************************************************************
function get_current_values($interface, $del, $delJitter, $delCorrelation, $delDistribution, $loss, $lossCorrelation, $dup, $dupCorrelation, $reorder, $reorderCorrelation, $gap, $bandwidth, $limit, $msFound, $src, $srcSub, $dest, $destSub, $addInt, $deleteInt) {
	global $tc_CMD;

	//Variable to return from the function: $ruleSets(The number of rule sets for the selected interface)

	//Get the output of "tc filter show"
	$output=shell_exec($tc_CMD . ' filter show dev ' . $interface);

	//Set $ruleSets to zero
	$ruleSets=0;

	//Find instances of the word "flowid" in $output
	//Set pointer to zero
	$i=0;
	while (strpos($output, 'flowid', $i)!==false):
		++$ruleSets;
		$i=strpos($output, 'flowid', $i) + 7;
		//Get the IP address data...

		$tmpStr="";
		//While $n doesn't point to a ':' character
		while (substr($output, $i, 1)!=":"):
			//Add character to $tmpStr
			$tmpStr=$tmpStr . substr($output, $i, 1);
			//increment $i
			$i=($i+1);
		endwhile;

		//**Set $x**
		//Divide $tmpStr by 10
		$tmpStr=$tmpStr/10;
		$tmpStr=$tmpStr - 1;
		//Round $tmpStr down to the nearest integer and assign to $x
		$x=floor($tmpStr);
		//Find next instance of "match" and set the pointer to the start of the ip address data
		$i=strpos($output, 'match', $i) + 6;

		//Get ip address data
		$tmpStr=substr($output, $i, 8);
		//Convert ip address to four octet format
		$ipAddr="";
		for ($m=0;$m<=7;$m=$m+2) {
			$ipAddr=$ipAddr . hexdec(substr($tmpStr,$m,2)) . ".";
		}
		//Remove trailing dot
		$ipAddr=substr($ipAddr,0,-1);

		//Get subnet data
		$i=$i+9;
		$tmpStr=substr($output, $i, 8);
		//Convert subnet to single number format
		$tmpStr=decbin(hexdec($tmpStr));
		$ipSubnet=0;
		for ($m=0;$m<strlen($tmpStr);++$m) {
			if (substr($tmpStr,$m,1)=="1") {
				++$ipSubnet;
			}
		}
		//Check whether it's the source or the destination address.  Set $src or $dest
		//to $ipAddr and set $srcSub or destSub to $ipSubnet. 12=source 16=dest
		//Set $n to the number after "at" 21 and 22
		
		//Do not add IP data if it is 0.0.0.0/0 (automatically generated filter rule to match all
		//other packets)
		if ($ipAddr!="0.0.0.0" & $ipSubnet!="0") {
			if (substr($output, $i+12, 2)==12) {
				$src[$x]=$ipAddr;
				$srcSub[$x]=$ipSubnet;
				$srcFound[$x]=true;
			} else {
				$dest[$x]=$ipAddr;
				$destSub[$x]=$ipSubnet;
				$destFound[$x]=true;
			}
		} else {
			//Subtract a rule set
			--$ruleSets;
		}

		//Check for a second occurance of the word 'match'
		//Get the part of $output after the first occurance of 'match'
		//$output=substr($output,$n);
		$secondMatch=false;
		//If there is another instance of match
		if (strpos($output, 'match', $i)) {
			if (strpos($output, 'flowid', $i)) {
				if (strpos($output, 'match', $i) < strpos($output, 'flowid', $i)) {
					//match is the second match for the same flowid
					$secondMatch=true;
				}
			} else {
				//match is the second match for the same flowid
				$secondMatch=true;
			}
		}
		if ($secondMatch==true) {
			//Set pointer to 6 spaces after the first instance of 'match'
			$i=strpos($output, "match", $i)+6;
			//Get ip address data
			$tmpStr=substr($output, $i, 8);
			//Convert ip address to four octet format
			$ipAddr="";
			for ($m=0;$m<=7;$m=$m+2) {
				$ipAddr=$ipAddr . hexdec(substr($tmpStr,$m,2)) . ".";
			}
			//Remove trailing dot
			$ipAddr=substr($ipAddr,0,-1);

			//Get subnet data
			$i=$i+9;
			$tmpStr=substr($output, $i, 8);
			//Convert subnet to single number format
			$tmpStr=decbin(hexdec($tmpStr));
			$ipSubnet=0;
			for ($m=0;$m<strlen($tmpStr);++$m) {
				if (substr($tmpStr,$m,1)=="1") {
					++$ipSubnet;
				}
			}
			//Check whether it's the source or the destination address.  Set $src or $dest
			//to $ipAddr and set $srcSub or destSub to $ipSubnet. 12=source 16=dest
			//Check whether it's the source or the destination address.  Set $src or $dest
			//to $ipAddr and set $srcSub or destSub to $ipSubnet. 12=source 16=dest
			//Set $n to the number after "at" 21 and 22
			if ($ipAddr!="0.0.0.0" & $ipSubnet!="0") {
				if (substr($output, $i+12, 2)==12) {
					$src[$x]=$ipAddr;
					$srcSub[$x]=$ipSubnet;
				} else {
					$dest[$x]=$ipAddr;
					$destSub[$x]=$ipSubnet;
				}
			}
		} else {
			if ($srcFound[$x]==false) {
				$src[$x]="any";
				$srcSub[$x]="";
			}
			if ($destFound[$x]==false) {
				$dest[$x]="any";
				$destSub[$x]="";
			}
 		}
	//End of pasted code.
	endwhile;

	//Check if no rulesets were found
	if ($ruleSets==0) {
		$ruleSets=1;
		//Set ip address data to default values
		$src[0]="any";
		$srcSub[0]="";
		$dest[0]="any";
		$destSub[0]="";
	}

	//Add one to $ruleSets if the add rule set button was clicked
	if ($addInt==1) {
		++$ruleSets;
		//Set ip address data to default values
		$src[$ruleSets-1]="any";
		$srcSub[$ruleSets-1]="";
		$dest[$ruleSets-1]="any";
		$destSub[$ruleSets-1]="";
		//$bandwidth[$ruleSets-1]="0";
		$_SESSION[addRuleSet]=true;
	}

	//Subtract one from $rulesets if the delete last rule set button was clicked
	if ($deleteInt==1) {
		--$ruleSets;
	}

	//If $output is empty then there are no values or there are only non-ip-matching values.
	//If this is the case then carry on with checking 'tc -d qdisc'

	//Get the tc status
	$output=shell_exec($tc_CMD.' -d qdisc');
	//Check for the word 'netem' in the output. If it's not there then there's no need to
	//carry on with this part of the function.
	if (strstr($output, "netem")!=FALSE) {
		//****Get the number of lines in $output and the starting character of each line****

		//Loop through all characters in $output
		for ($i = 0; $i <= strlen($output); $i++) {
			//Check each character in turn to see if it has an ascii value of 10
			//ascii 10 = linefeed character
			if (ord(substr($output, $i, 1)) == 10) {
				//if a linefeed character was found then add 1 to lines
				$lines=$lines+1;
				//Add the starting character of the next line to the array $lineStart
				$lineStart[] = $i+1;
			}
		}
		//Loop through the number of interface instances in $ruleSets
		for ($r=1; $r<=$ruleSets; $r++) {

			//Set selected interface variable
			$selectedInterface=$interface;

			//Reset variables that will be used to show which rules were found and which ones
			//weren't
			$delFound=FALSE;
			$lossFound=FALSE;
			$dupFound=FALSE;
			$reorderFound=FALSE;
			$bandwidthFound=FALSE;

			//Loop through lines
			for ($i = 0; $i < $lines; $i++) {
				//If on the first line then set pointer($n) to first character else set it to
				//the corresponding $linestart value
				if ($i==0) {
					$n=0;
				} else {
					$n=$lineStart[$i-1];
				}
				//Check if the first word in the line is 'qdisc', if it is then carry on processing
				//if not then do nothing and move to the next line.
				if (substr($output, $n, 5) == "qdisc") {

					//**Get the qdisc name**
					//Empty $tmpStr
					$tmpStr="";
					//Set $n to point to 6 characters into the line
					$n=($n+6);
					//While $n doesn't point to a space character
					while (ord(substr($output, $n, 1))!=32):
						//Add character to $tmpStr
						$tmpStr=$tmpStr . substr($output, $n, 1);
						//increment $n
						$n=($n+1);
					endwhile;
					//**Check if the qdisc name is 'netem'**
					if ($tmpStr=='netem') {
						//Get current line into a string
						if ($i==0) {
							$lineStr=substr($output, 0, ($lineStart[0]-1));
						} else {
							$lineStr=substr($output, $lineStart[$i-1], (($lineStart[$i]-1)-$lineStart[$i-1]));
						}

						//**Get qdisc handle (6 space after the beginning of 'netem')
						//This will only be needed if there is more than one ruleset
						//Reset $tmpStr
						$tmpStr="";
						if ($ruleSets > 1) {
							$n=(strpos($lineStr, 'netem') + 6);
							while (substr($lineStr, $n, 1)!=":"):
								//Add character to $tmpStr
								$tmpStr=$tmpStr . substr($lineStr, $n, 1);
								//increment $n
								++$n;
							endwhile;
							//Check qdisc handle number and set the interface instance($x) accordingly.
							//10-19=1,20-29=2,30-39=3.. etc
							//Subtract 10 from $tmpStr
							$tmpStr-=10;
							//Divide $tmpStr by 10
							$tmpStr=$tmpStr/10;
							//Round $tmpStr down to the nearest integer and assign to $x
							$x=floor($tmpStr);
						} else {
							//Else just set $x to 0
							$x=0;
						}

						//**Get interface name**
						//Move the pointer to 4 characters after the start of 'dev'
						$n=(strpos($lineStr, 'dev')+4);
						//Reset $tmpStr2
						$tmpStr2="";
						while (substr($lineStr, $n, 1)!=" "):
							//Add character to $tmpStr
							$tmpStr2=$tmpStr2 . substr($lineStr, $n, 1);
							//increment $n
							++$n;
						endwhile;
						//Set $limitFound to false, this flag will be used so that
						//the $limit value for the interface is only checked once
						$limitFound=false;

						//Check if interface name matches selected interface
						if ($tmpStr2==$selectedInterface) {

							//**Get netem values and set the correct $_POST variables**
							//Check for delay
							if (strstr($lineStr, "delay")!=FALSE) {
								//Set $delFound to TRUE
								$delFound[$x]=TRUE;
								//Set $n to start of delay time value
								$n=(strpos($lineStr, "delay")+6);

								//****************
								//Get delay values
								//****************

								//**Get delay time**
								//Reset tmpStr3
								$tmpStr3="";
								//$usFound will be set to true when 999us is found and
								//therefore the value is 1ms.  This is just a quirk of the delay
								//command.
								$usFound=false;
								$gotNumber=false;
								while ($gotNumber==false):
									//If character is not '.' or 'u'
									if (substr($lineStr, $n, 1)!="." & substr($lineStr, $n, 1)!="u")  {
										//Add character to $tmpStr
										$tmpStr3=$tmpStr3 . substr($lineStr, $n, 1);
										//increment $n
										$n=($n+1);
									} else {
										//else set $gotNumber to true
										$gotNumber=true;
										if (substr($lineStr, $n, 1)=="u") {
											$usFound=true;
										}
									}
								endwhile;

								if ($usFound==false) {
									$tmpStr4="";
									$z=$n+1;
									//set tmpStr4 to $tmpStr3 plus a decimal point
									$tmpStr4=$tmpStr3 . ".";
									$msFound=false;
									//while $z is not pointing at an "s"
									while (substr($lineStr, $z, 1)!="s"):
										//if a "m" is found
										if (substr($lineStr, $z, 1)=="m") {
											$msFound=true;
										//else it will be the number after the decimal point
										} else {
											$tmpStr4=$tmpStr4 . substr($lineStr, $z, 1);
										}
										++$z;
									endwhile;
								}

								//Set delay variable to tmpStr3 or tmpStr4 depending on
								//whether delay is over a second or not
								if ($usFound==false) {
									if ($msFound==false) {
										$del[$x]=$tmpStr4*1000;
									} else {
										$del[$x]=$tmpStr3;
									}
								} else {
									$del[$x]=1;
								}

								//**Get delay jitter**
								//Check for delay jitter if there was a delay time value
								if (($tmpStr3!="") and (strlen($lineStr) > ($n+6))) {
									//increment $n by 5 or 6 to get to first jitter character
									if ($msFound==true) {
										$n=($n+6);
									} else {
										$n=($n+5);
									}
									if (is_numeric(substr($lineStr, $n, 1))) {
										//Get delay jitter
										//Reset tmpStr3
										$tmpStr3="";
										//$usFound will be set to true when 999us is found and
										//therefore the value is 1ms.  This is just a quirk of the delay
										//command.
										$usFound=false;
										$gotNumber=false;
										while ($gotNumber==false):
											//If character is not '.' or 'u'
											if (substr($lineStr, $n, 1)!="." & substr($lineStr, $n, 1)!="u")  {
												//Add character to $tmpStr
												$tmpStr3=$tmpStr3 . substr($lineStr, $n, 1);
												//increment $n
												$n=($n+1);
											} else {
												//else set $gotNumber to true
												$gotNumber=true;
												if (substr($lineStr, $n, 1)=="u") {
													$usFound=true;
												}
											}
										endwhile;

										if ($usFound==false) {
											$tmpStr4="";
											$z=$n+1;
											//set tmpStr4 to $tmpStr3 plus a decimal point
											$tmpStr4=$tmpStr3 . ".";
											$msFound=false;
											//while $z is not pointing at an "s"
											while (substr($lineStr, $z, 1)!="s"):
												//if a "m" is found
												if (substr($lineStr, $z, 1)=="m") {
													$msFound=true;
												//else it will be the number after the decimal point
												} else {
													$tmpStr4=$tmpStr4 . substr($lineStr, $z, 1);
												}
												++$z;
											endwhile;
										}

										//Set delay jitter variable to tmpStr3 or tmpStr4 depending on
										//whether delay is over a second or not
										if ($usFound==false) {
											if ($msFound==false) {
												$delJitter[$x]=$tmpStr4*1000;
											} else {
												$delJitter[$x]=$tmpStr3;
											}
										} else {
											$delJitter[$x]=1;
										}
									} else {
										//Set delay jitter variable to zero
										$delJitter[$x]="0";
									}
								} else {
									$tmpStr3="";
									//Set delay jitter variable to zero
									$delJitter[$x]="0";
								}

								//**Get delay correlation**
								//Check for delay correlation if there was a delay correlation
								//value
								if (($tmpStr3!="") and (strlen($lineStr) > ($n+5))) {
									//increment $n by 5 to get to start of delay correlation
									//value
									$n=($n+5);
									if (is_numeric(substr($lineStr, $n, 1))) {
										//Get delay jitter
										//Reset tmpStr3
										$tmpStr3="";
										//While $n not pointing at a '%' character
										while (ord(substr($lineStr, $n, 1))!=37):
											//Add character to $tmpStr
											$tmpStr3=$tmpStr3 . substr($lineStr, $n, 1);
											//increment $n
											$n=($n+1);
										endwhile;

										//Set delay correlation variable to tmpStr3
										$delCorrelation[$x]=$tmpStr3;
									} else {
										//Set delay correlation variable to zero
										$delCorrelation[$x]="0";
									}
								} else {
									//Set delay correlation variable to zero
									$delCorrelation[$x]="0";
								}
							}

							//Check for loss
							if ((strstr($lineStr, "loss")!=FALSE)) {
								//Set $lossFound to TRUE
								$lossFound[$x]=TRUE;
								//Set $n to start of loss value
								$n=(strpos($lineStr, "loss")+5);

								//****************
								//Get loss values
								//****************
								//Get loss
								//Reset tmpStr3
								$tmpStr3="";
								//While $n not pointing at a '%' character
								while (ord(substr($lineStr, $n, 1))!=37):
									//Add character to $tmpStr
									$tmpStr3=$tmpStr3 . substr($lineStr, $n, 1);
									//increment $n
									$n=($n+1);
								endwhile;
								//Set loss variable to tmpStr3
								$loss[$x]=$tmpStr3;

								//**Get loss correlation**
								//Check for loss correlation if there was a loss correlation
								//value
								if (($tmpStr3!="") and (strlen($lineStr) > ($n+2))) {
									//increment $n by 2 to get to start of loss correlation value
									$n=($n+2);
									if (is_numeric(substr($lineStr, $n, 1))) {
										//Get loss correlation
										//Reset tmpStr3
										$tmpStr3="";
										//While $n not pointing at a '%' character
										while (ord(substr($lineStr, $n, 1))!=37):
											//Add character to $tmpStr
											$tmpStr3=$tmpStr3 . substr($lineStr, $n, 1);
											//increment $n
											$n=($n+1);
										endwhile;

										//Set loss correlation variable to tmpStr3
										$lossCorrelation[$x]=$tmpStr3;
									}
								} else {
									//Set loss correlation variable to zero
									$lossCorrelation[$x]="0";
								}
							}

							//Check for duplication
							if ((strstr($lineStr, "duplicate")!=FALSE)) {
								//Set $dupFound to TRUE
								$dupFound[$x]=TRUE;
								//Set $n to start of duplicate value
								$n=(strpos($lineStr, "duplicate")+10);

								//**********************
								//Get duplication values
								//**********************
								//Get duplication
								//Reset tmpStr3
								$tmpStr3="";
								//While $n not pointing at a '%' character
								while (ord(substr($lineStr, $n, 1))!=37):
									//Add character to $tmpStr
									$tmpStr3=$tmpStr3 . substr($lineStr, $n, 1);
									//increment $n
									$n=($n+1);
								endwhile;

								//Set duplication variable to tmpStr3
								$dup[$x]=$tmpStr3;

								//**Get duplication correlation**
								//Check for duplication correlation if there was a loss
								//correlation value
								if (($tmpStr3!="") and (strlen($lineStr) > ($n+2))) {
									//increment $n by 2 to get to start of duplication
									//correlation value
									$n=($n+2);
									if (is_numeric(substr($lineStr, $n, 1))) {
										//Get duplication correlation
										//Reset tmpStr3
										$tmpStr3="";
										//While $n not pointing at a '%' character
										while (ord(substr($lineStr, $n, 1))!=37):
											//Add character to $tmpStr
											$tmpStr3=$tmpStr3 . substr($lineStr, $n, 1);
											//increment $n
											$n=($n+1);
										endwhile;

										//Set duplication correlation variable to tmpStr3
										$dupCorrelation[$x]=$tmpStr3;
									}
								} else {
									//Set duplication correlation variable to zero
									$dupCorrelation[$x]="0";
								}
							}

							//Check for reorder
							if ((strstr($lineStr, "reorder")!=FALSE)) {
								//Set $reorderFound to TRUE
								$reorderFound[$x]=TRUE;
								//Set $n to start of reorder value
								$n=(strpos($lineStr, "reorder")+8);
								//**********************
								//Get reorder values
								//**********************
								//**Get reorder**
								//Reset tmpStr3
								$tmpStr3="";
								//While $n not pointing at a % character
								while (ord(substr($lineStr, $n, 1))!=37):
									//Add character to $tmpStr
									$tmpStr3=$tmpStr3 . substr($lineStr, $n, 1);
									//increment $n
									++$n;
								endwhile;

								//Set reorder variable to tmpStr3
								$reorder[$x]=$tmpStr3;

								//**Get reorder correlation**
								//Check if substr($lineStr, $n+2, 1)="g" (Start of the word "gap" or if it
								//is a number (start of correlation value)
								//Set $n to start of delay time value
								if (substr($lineStr, $n+2, 1)!="g") {
									//Add 2 to $n to move the pointer to the start of the reorder
									//correlation value
									$n=$n+2;
									$tmpStr3="";
									//While $n not pointing at a % character
									while (ord(substr($lineStr, $n, 1))!=37):
										//Add character to $tmpStr
										$tmpStr3=$tmpStr3 . substr($lineStr, $n, 1);
										//increment $n
										$n=($n+1);
									endwhile;

								//Set reorder variable to tmpStr3
								$reorderCorrelation[$x]=$tmpStr3;
								} else {
									//Set reorder correlation variable to zero
									$reorderCorrelation[$x]="0";
								}

								//**Get gap value**
								$n=(strpos($lineStr, "gap")+4);
								//Reset tmpStr3
								$tmpStr3="";
								//While $n not pointing at a newline character
								while ($n <= strlen($lineStr)):
									//Add character to $tmpStr
									$tmpStr3=$tmpStr3 . substr($lineStr, $n, 1);
									//increment $n
									$n=($n+1);
								endwhile;

								//Set gap variable to tmpStr3
								$gap[$x]=$tmpStr3;

							}
							//**Check for limit value**
							//Look for first occurence of 'limit' in $output. It doesn't
							//matter where the first occurence is because all limits will
							//be the same unless the user manually typed commands with
							//different limits.
							if ($limitFound==false) {
								$output2=shell_exec($tc_CMD.' -d qdisc');
								$n=strpos($output2, "limit");
								if ($n===false) {
									//If a limit value was not found then set it to the default
									//value of 1000
									$limit[$x]=1000;
								} else {
									//Set $n to 6 spaces after 'limit'
									$n=$n+6;
									$tmpStr3="";
									while (ord(substr($output2, $n, 1))!=32):
										//Add character to $tmpStr
										$tmpStr3=$tmpStr3 . substr($output2, $n, 1);
										//increment $n
										$n=($n+1);
									endwhile;
									$limit[$x]=$tmpStr3;
								}
								$limitFound=true;
							}
						}
					}
				}
			}

			//Set non-found netem values to zero
			for ($n=0; $n<$ruleSets; ++$n) {
				if ($delFound[$n]==FALSE) {
					$del[$n]="0";
					$delJitter[$n]="0";
					$delCorrelation[$n]="0";
					$delDistribution[$n]="-N/A-";
				}
				if ($lossFound[$n]==FALSE) {
					$loss[$n]="0";
					$lossCorrelation[$n]="0";
				}
				if ($dupFound[$n]==FALSE) {
					$dup[$n]="0";
					$dupCorrelation[$n]="0";
				}
				if ($reorderFound[$n]==FALSE) {
					$reorder[$n]="0";
					$reorderCorrelation[$n]="0";
					$gap[$n]="0";
				}
				if ($limit[$n]=="") {
					$limit[$n]=1000;
				}
			}
		}
	} else {
		//Show all values as zero
		//Loop through all interface instances
		for ($x=0; $x<$ruleSets; $x++) {
			$del[$x]="0";
			$delJitter[$x]="0";
			$delCorrelation[$x]="0";
			$loss[$x]="0";
			$lossCorrelation[$x]="0";
			$dup[$x]="0";
			$dupCorrelation[$x]="0";
			$reorder[$x]="0";
			$reorderCorrelation[$x]="0";
			$gap[$x]="0";
			$limit[$x]=1000;
		}
	}
	//**Check for 'htb'**

	//Loop through all interface instances
	for ($r=0; $r<$ruleSets; $r++) {
		//Get the tc class status
		$output=shell_exec($tc_CMD.' class show dev ' . $interface);

		//****Get the number of lines in $output and the starting character of each line****

		//Loop through all characters in $output
		for ($i = 0; $i <= strlen($output); $i++) {
			//Check each character in turn to see if it has an ascii value of 10
			//ascii 10 = linefeed character
			if (ord(substr($output, $i, 1)) == 10) {
				//if a linefeed character was found then add 1 to lines
				$lines=$lines+1;
				//Add the starting character of the next line to the array $lineStart
				$lineStart2[] = $i+1;
			}
		}
		//Loop through lines
		for ($i = 0; $i < $lines; $i++) {
			//If on the first line then set pointer($n) to first character else set it to
			//the corresponding $linestart value
			if ($i==0) {
				$n=0;
			} else {
				$n=$lineStart2[$i-1];
			}
			//Get current line into a string
			if ($i==0) {
				$lineStr=substr($output, 0, ($lineStart2[0]-1));
			} else {
				$lineStr=substr($output, $lineStart2[$i-1], (($lineStart2[$i]-1)-$lineStart2[$i-1]));
			}
			if (strstr($lineStr, "htb")!=FALSE & strstr($lineStr, "rate")!=FALSE) {
				//**Get htb handle (4 space after the beginning of 'htb')
				//This will only be needed if there is more than one ruleset
				//Reset $tmpStr
				$tmpStr="";
				if ($ruleSets > 1) {
					$n=(strpos($lineStr, 'htb') + 4);

					//Get htb major number into $tmpStr
					while (substr($lineStr, $n, 1)!=":"):
						//Add character to $tmpStr
						$tmpStr=$tmpStr . substr($lineStr, $n, 1);
						//increment $n
						++$n;
					endwhile;
					//Check qdisc handle number and set the interface instance($x) accordingly.
					//10-19=1,20-29=2,30-39=3.. etc
					//Subtract 10 from $tmpStr
					$tmpStr-=10;
					//Divide $tmpStr by 10
					$tmpStr=$tmpStr/10;
					//Round $tmpStr down to the nearest integer and assign to $x
					$x=floor($tmpStr);
				} else {
					//Else just set $x to 0
					$x=0;
				}

				//Set $n to start of bandwidth value
				$n=(strpos($lineStr, "rate")+5);

				//**********************
				//Get bandwidth value
				//**********************
				//Get bandwidth (Kbits/s)
				//Reset tmpStr3
				$tmpStr3="";
				$gotNumber=false;
				while ($gotNumber==false):
					//If character is not 'b', 'K', or 'M'
					if (substr($lineStr, $n, 1)!="b" & substr($lineStr, $n, 1)!="K" & substr($lineStr, $n, 1)!="M") {
						//Add character to $tmpStr
						$tmpStr3=$tmpStr3 . substr($lineStr, $n, 1);
						//increment $n
						$n=($n+1);
					} else {
						//else set $gotNumber to true
						$gotNumber=true;
					}
				endwhile;
				//Check whether $n is 'b', 'K' or 'M' and convert $tmpStr3 accordingly
				if (substr($lineStr, $n, 1)=="b") {
					$bandwidth[$x]=$tmpStr3/1000;
				} elseif (substr($lineStr, $n, 1)=="K") {
					$bandwidth[$x]=$tmpStr3;
				} elseif (substr($lineStr, $n, 1)=="M") {
					$bandwidth[$x]=$tmpStr3*1000;
				}
				$bandwidthFound[$x]=true;
			}
		}
	}
	//Set non-found bandwidth values to zero
	for ($x=0; $x<$ruleSets; $x++) {
		if ($bandwidthFound[$x]==false) {
			$bandwidth[$x]=0;
		}
	}
	return $ruleSets;
}
?>
